function  [gab gab1] = filter_gabor(tx, ty, angle, f) 

xx = [-16:16];
yx = [-16:16];

[x, y] = meshgrid(xx,yx);

xp = sin(angle) .* x + cos(angle) .* y;
yp = sin(angle) .* y - cos(angle) .* x;
gab = exp(-0.5 * ((xp.^2 / tx^2) + (yp.^2/ty^2))) .* cos(2 * pi * f .* xp);

for m = xx
    for n = yx
        xp = sin(angle)*m + cos(angle)*n;
        yp = sin(angle)*n - cos(angle)*m;
        gab1(n + 17, m + 17) = exp(-.5*(xp^2/tx^2 + yp^2/ty^2))*cos(2*pi*f*xp);
    end
end

% imfilt = imfilter(im, gab, 'replicate', 'same');
% 
% imfilt = mat2gray(imfilt);